package com.gree.mall.manager.logic;

import cn.hutool.core.date.DateUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.gree.mall.manager.bean.policy.ItfGreeSynDownloadRecBean;
import com.gree.mall.manager.constant.Constant;
import com.gree.mall.manager.plus.entity.ItfGreeSynDownloadRec;
import com.gree.mall.manager.plus.entity.ItfGreeSynRule;
import com.gree.mall.manager.plus.service.ItfGreeSynDownloadRecService;
import com.gree.mall.manager.plus.service.ItfGreeSynRuleService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@Slf4j
@RequiredArgsConstructor
public class SyncOrderInfoLogic {

    @Autowired
    ItfGreeSynRuleService itfGreeSynRuleService;

    @Autowired
    ItfGreeSynDownloadRecService itfGreeSynDownloadRecService;

    @Value("${gree.url}")
    private  String greeUrl;

    public void syncGuang() {
        ItfGreeSynRule itfGreeSynRule = itfGreeSynRuleService.lambdaQuery().eq(ItfGreeSynRule::getSalesWebsitNumber, Constant.gree.GUANGZHOUXIAOSI)
                .one();

        Long time = itfGreeSynRule.getLastSynTime().getTime()/1000;


        String body = HttpRequest.get(greeUrl+ Constant.gree.GET_UPDATE_ORDERS+"/"+Constant.gree.GUANGZHOUXIAOSI+"/"+time).execute().body();

        Map<String,Object> bodyMap = JSON.parseObject(body);

        log.info("【工单同步数据内容】:"+bodyMap.get("data").toString());

        JSONArray jsonArray = JSONUtil.parseArray(JSON.parseObject(bodyMap.get("data").toString()));


        List<ItfGreeSynDownloadRecBean> itfGreeSynDownloadRecBeans = JSONUtil.toList(jsonArray, ItfGreeSynDownloadRecBean.class);

        if (CollectionUtils.isEmpty(itfGreeSynDownloadRecBeans))
            return;

        List<ItfGreeSynDownloadRec> itfGreeSynDownloadRecs = new ArrayList<>();

        Date date = new Date();

        for (ItfGreeSynDownloadRecBean itfGreeSynDownloadRecBean : itfGreeSynDownloadRecBeans) {
            ItfGreeSynDownloadRec itfGreeSynDownloadRec = new ItfGreeSynDownloadRec();
        }


    }

    public void syncFo() {
    }
}
